CREATE DATABASE IF NOT EXISTS `database`;

USE `database`;

CREATE TABLE IF NOT EXISTS `user` (
    id BIGINT AUTO_INCREMENT PRIMARY KEY,
    dni VARCHAR(55) NOT NULL,
    email VARCHAR(255) NOT NULL UNIQUE,
    password VARCHAR(255) NOT NULL,
    name VARCHAR(255) NOT NULL,
    surname VARCHAR(255) NOT NULL,
    phone VARCHAR(55) NOT NULL,
    address VARCHAR(255) NOT NULL,
    subscription VARCHAR(255) NOT NULL DEFAULT ''
);

CREATE TABLE IF NOT EXISTS `user_recover` (
    id BIGINT AUTO_INCREMENT PRIMARY KEY,
    uid BIGINT NOT NULL,
    code VARCHAR(6) NOT NULL,
    expires VARCHAR(255) NOT NULL,
    FOREIGN KEY (uid) REFERENCES `user` (id) ON DELETE CASCADE
);

CREATE TABLE IF NOT EXISTS `profile` (
    id BIGINT AUTO_INCREMENT PRIMARY KEY,
    uid BIGINT NOT NULL,
    name VARCHAR(55) NOT NULL UNIQUE,
    nickname VARCHAR(55) NOT NULL,
    description VARCHAR(255) NOT NULL DEFAULT '',
    image BLOB NOT NULL,
    image_header BLOB NOT NULL,
    color VARCHAR(25) NOT NULL DEFAULT '',
    FOREIGN KEY (uid) REFERENCES `user` (id) ON DELETE CASCADE
);

CREATE TABLE IF NOT EXISTS `profile_code` (
    id BIGINT AUTO_INCREMENT PRIMARY KEY,
    pid BIGINT NOT NULL,
    url VARCHAR(255) NOT NULL DEFAULT '',
    image BLOB NOT NULL,
    FOREIGN KEY (pid) REFERENCES `profile` (id) ON DELETE CASCADE
);

CREATE TABLE IF NOT EXISTS `category` (
    id BIGINT AUTO_INCREMENT PRIMARY KEY,
    pid BIGINT NOT NULL,
    name VARCHAR(255) NOT NULL,
    status TINYINT NOT NULL DEFAULT 1,
    FOREIGN KEY (pid) REFERENCES `profile` (id) ON DELETE CASCADE
);

CREATE TABLE IF NOT EXISTS `product` (
    id BIGINT AUTO_INCREMENT PRIMARY KEY,
    pid BIGINT NOT NULL,
    cid BIGINT NOT NULL,
    name VARCHAR(255) NOT NULL,
    status TINYINT NOT NULL DEFAULT 1,
    description VARCHAR(255) NOT NULL DEFAULT '',
    outstanding TINYINT NOT NULL DEFAULT 0,
    price DECIMAL(10, 2) NOT NULL DEFAULT 0.0,
    discount VARCHAR(25) NOT NULL DEFAULT '',
    image BLOB NOT NULL,
    size VARCHAR(255) NOT NULL DEFAULT '',
    vegan TINYINT NOT NULL DEFAULT 0,
    gluten TINYINT NOT NULL DEFAULT 0,
    spicy VARCHAR(25) NOT NULL DEFAULT '',
    calories INT NOT NULL DEFAULT 0,
    delay INT NOT NULL DEFAULT 0,
    FOREIGN KEY (pid) REFERENCES `profile` (id) ON DELETE CASCADE,
    FOREIGN KEY (cid) REFERENCES `category` (id) ON DELETE CASCADE
);
